//+------------------------------------------------------------------+
//|                                                           MACD-2 |
//+------------------------------------------------------------------+
#property copyright  ""
#property link       ""
#property strict
#property indicator_separate_window
//---
#property indicator_buffers 4
#property indicator_type1 DRAW_HISTOGRAM
#property indicator_type2 DRAW_HISTOGRAM
#property indicator_type3 DRAW_LINE
#property indicator_type4 DRAW_LINE
//---
#property indicator_color1 clrGreen
#property indicator_color2 clrTomato
#property indicator_color3 clrRed
#property indicator_color4 clrBlack
//---
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
//---
#property indicator_label1 "Histo Plus"
#property indicator_label2 "Histo Minus"
#property indicator_label3 "Main"
#property indicator_label4 "Signal"


//---- indicator parameters
extern uint FastEMA    = 23;//Fast
extern uint SlowEMA    = 30;//Slow
extern uint SignalEMA  = 22;//Signal
//---- indicator buffers
double ind_buffer1[];
double ind_buffer2[];
double ind_buffer3[];
double ind_buffer4[];
int max_period;
//+------------------------------------------------------------------+
//|   OnInit                                                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   FastEMA = fmax(FastEMA,1);
   SlowEMA = fmax(SlowEMA,1);
   SignalEMA=fmax(SignalEMA,1);
   max_period=(int)SignalEMA+(int)fmax(FastEMA,SlowEMA);

//---- 4 indicator buffers mapping
   SetIndexBuffer(0,ind_buffer1);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexBuffer(2,ind_buffer3);
   SetIndexBuffer(3,ind_buffer4);

//---- drawing settings
   SetIndexDrawBegin(0,SignalEMA);
   SetIndexDrawBegin(1,SignalEMA);
   SetIndexDrawBegin(2,SignalEMA);
   SetIndexDrawBegin(3,SignalEMA);
//---
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
//---   
   string name=StringFormat("MACD-2 %d,%d,%d",FastEMA,SlowEMA,SignalEMA);
   IndicatorSetString(INDICATOR_SHORTNAME,name);
   IndicatorDigits(_Digits+1);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|   OnCalculate                                                    |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   if(rates_total<max_period)
      return(0);
//---
   int limit;
   if(prev_calculated==0)
      limit=rates_total-max_period;
   else
      limit=rates_total-prev_calculated;

//--- main line
   for(int i=limit; i>=0 && !_StopFlag; i--)
      ind_buffer3[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

//--- signal
   for(int i=limit; i>=0 && !_StopFlag; i--)
      ind_buffer4[i]=iMAOnArray(ind_buffer3,0,SignalEMA,0,MODE_EMA,i);

//--- histo
   for(int i=limit; i>=0 && !_StopFlag; i--)
     {
      double current=ind_buffer3[i]-ind_buffer4[i];
      double prev=ind_buffer3[i+1]-ind_buffer4[i+1];
      if(current>prev)
        {
         ind_buffer1[i]=3*current;
         ind_buffer2[i]=0;
        }
      else
        {
         ind_buffer1[i]=0;
         ind_buffer2[i]=3*current;
        }
     }

//--- done     
   return(rates_total);
  }
//+------------------------------------------------------------------+
